﻿Imports MediaCy.IQL.Sets
Imports MediaCy.Commands

Public Module Macros

    Public Sub ExtractMacro91()
        Dim docList, doc, edf

        ' Load the image sets without displaying them
        With Application.DocumentCommands.Open(Nothing)
            .Visible=False
            .Run(docList)
        End With

        For Each doc In docList

            ' Process each image set in the collection
            Dim imageSet As McImageSet = TryCast(doc.Data,McImageSet)
            If imageSet Is Nothing Then
                MsgBox "Ignoring single channel image"
                Continue For
            End If

            ' How many channels?
            Dim numChannels As Integer = imageSet.GetMaximumDimensionLength(mcImageSetDimensions.mcisdChannel)

            For channel As Integer = 0 To numChannels -1

                ' Extract a Z-stack for each channel
                Dim locations As McImageSetLocations = ThisApplication.CreateOperator("McImageSetLocations")
                locations.Add(mcImageSetDimensions.mcisdChannel,channel)
                Dim sources As McImageSetSources = imageSet.GetSourcesAlongDimension(locations,mcImageSetDimensions.mcisdZ)

                ' Here to simplify we only support sets with all Z sources in one image
                If Not sources.Count = sources.Item(0).Image.FrameCount Then
                    MsgBox "Ignoring unsupported image source"
                    Continue For
                End If
                Dim zstack As McImage = sources.Item(0).Image.Duplicate(mcImageCreateFlags.mcicfDefault)
                zstack.DisplayName = "Z stack " & channel & " from " & imageSet.Name
                zstack.Visible = True

                ' Run EDF on each Z-stack
                With Process.EDF.WindowsCommands.Clear(Nothing)
                    .Run()
                End With

                With Process.EDF.WindowsCommands.Add(Nothing)
                    .Run(zstack)
                End With

                With Process.EDFCommands.Apply(Nothing)
                    .Run(edf, Nothing)
                End With
            Next

            ' Remove the image set from its collection to release memory
            imageSet.ParentCollection.Remove(imageSet)

        Next


    End Sub

End Module
